using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.ComponentModel;    

namespace Reveal
{
    [TypeConverter(typeof(MyPointConverter))]
    public class MyPoint 
    {
        protected Point m_pt;
        //private TypeConverter converter = new MyPointConverter();

        public MyPoint(int x, int y)
        {
            m_pt.X = x;
            m_pt.Y = y;
        }

        public MyPoint(Point pt) : this(pt.X, pt.Y) {}

        public int X
        {
            get { return m_pt.X; }
            set { m_pt.X = value; }
        }

        public int Y
        {
            get { return m_pt.Y; }
            set { m_pt.Y = value; }
        }

        public static implicit operator Point(MyPoint pt)
        {
            return new Point(pt.X, pt.Y);
        }

        public static MyPoint operator +(MyPoint pt1, MyPoint pt2)
        {
            return new MyPoint(pt1.X + pt2.X, pt1.Y + pt2.Y);
        }

        public static Rectangle operator +(Rectangle rect, MyPoint pt)
        {
            return new Rectangle(new MyPoint(rect.Location) + pt, rect.Size);
        }

        public static MyPoint operator -(MyPoint pt1, MyPoint pt2)
        {
            return new MyPoint(pt1.X - pt2.X, pt1.Y - pt2.Y);
        }
        
    }
}
